# matrix-appservice-kakaotalk - A Matrix-KakaoTalk puppeting bridge.
# Copyright (C) 2022 Tulir Asokan, Andrew Ferrazzutti
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with this program.  If not, see <https://www.gnu.org/licenses/>.
from typing import Any, Optional

from mautrix.types import Serializable, JSON


class Long(int, Serializable):
    def serialize(self) -> JSON:
        return {"__type__": "Long", "str": str(self)}

    @classmethod
    def deserialize(cls, raw: JSON) -> "Long":
        return cls(raw)

def to_optional_long(x: Optional[Any]) -> Optional[Long]:
    return Long(x) if x is not None else None
